#ifndef MCMC_CK
#define MCMC_CK

#include "DispMessage.h"
#include"RNP2to191.h"

using namespace EstPolychoric;
using namespace rnp2to191;

namespace MyMCMC {

	ref class MCMCPolyChoric {
	public:
		String ^ hstr;
		RNP2to191 * rn;
		int Kx, Ky;
		double * Cx, * Cy;
		int * X, * Y;
		double * rho;
		int ** Nkh;
		int N;
		int NSimu;
		double sgm_rho;
		int cnt_rho;

		MCMCPolyChoric(){}
		virtual ~MCMCPolyChoric(){
			ClearMe();
		}
		!MCMCPolyChoric(){
			ClearMe();
		}

		void ClearMe();

		void Init(String ^ vhstr, int vnjump, int vNSimu, int vKx, int vKy, int vN, int * vX, int * vY,
					double init_rho, double * vCx, double * vCy,
					double vsgm_rho);
		
		double LProbAll(double vrho);

		void do_mcmc();
		
	};
}

#endif
